Type _fps
   
   Declare Constructor(FPS As Integer)
   Declare Function IsTime() As Integer
      
   'Render Loop Timing
   nextframe As Double = Timer
   lastframe As Double = Timer 
   tmrFreeze As Double
   GAMETICK  As Double
   FRate     As Integer

Public:

   elapsed   As Double 
   
End Type

Constructor _fps(FPS As Integer)

   GAMETICK = 1/FPS
   FRate = FPS
   
End Constructor

Function _fps.IsTime() As Integer
   
   'Save current timer
   tmrFreeze = Timer 
   
   'Test if time for next frame
   If tmrFreeze > nextframe Then
      
      'Calculate elapsed time and time for next frame
      elapsed   = tmrFreeze - lastframe
      lastframe = tmrFreeze         
      nextframe = tmrFreeze + GAMETICK 
      
      Return 1
      
   End If
   
   Return 0
   
End Function
