Type _MEVENTARGS
   x      As Integer
   y      As Integer
   wheel  As Integer
   button As Integer
   clip   As Integer
   object As Any Ptr
End Type

Type _hotspot
   
   _idx As Integer
   _x   As Integer
   _y   As Integer
   _dx  As Integer
   _dy  As Integer
   
   args As _MEVENTARGS
   
   Declare Constructor()
   Declare Destructor()
   
   Declare Sub Initialize (idx As Integer, x As Integer, y As Integer, dx As Integer, dy As Integer, callback As Any Ptr)
   Declare Sub DrawMe(dest As Any Ptr)
   Declare Sub Process(GameState As Any Ptr)
   
   OnClick As Sub (hotspot As _hotspot Ptr, args As _MEVENTARGS)
   
End Type

Constructor _hotspot()
End Constructor

Destructor _hotspot()
End Destructor

Sub _hotspot.Initialize(idx As Integer, x As Integer, y As Integer, dx As Integer, dy As Integer, callback As Any Ptr)

   _idx = idx
   _x   = x
   _y   = y
   _dx  = dx
   _dy  = dy
   OnClick = callback
   
End Sub

Sub _hotspot.Process(GameState As Any Ptr)
Static lastbtn As Integer

   GetMouse(args.x, args.y, args.wheel, args.button, args.clip)
   'Line (_x,_y)-Step(_dx,_dy),&hFFFF00,B
      
   If (args.x >= _x) And (args.x <= _x+_dx) then
      If (args.y >= _y) And (args.y <= _y+_dy) Then
         If (OnClick<>0) And (args.button <> lastbtn) Then
            If (args.button And 1) Then
               args.object = GameState
               OnClick(@This, args)
            EndIf
            lastbtn = args.button
         EndIf
      End If
   EndIf   
   
End Sub
