' Font Object for use with
' CharSet2FBFont written by Muttonhead (muttonhead@hotmail.de)
'
Type _Font

   Public:

   Declare Constructor()
   Declare Constructor (fontdir As String)
   Declare Destructor()
   Declare Function LoadFBFont (Filename As String) As Any Ptr
   
   Declare Sub DrawString(dest As Any Ptr=0, x As Integer, y As Integer, text As String)
   Declare Sub SetColor(clr As UInteger)

   ErrorCode As Integer

   Private:

   fbfont As UByte Ptr

End Type

Constructor _Font(fontdir As String)

   FBfont = LoadFBFont(fontdir+"\font.bmp")

End Constructor

Destructor _Font()

If fbfont Then ImageDestroy(fbfont)

End Destructor

Sub _Font.SetColor(clr As UInteger)
   Dim As Integer h,w,bpp,pitch,size
   Dim As UByte Ptr pixels
   Dim As UInteger Ptr pix

   ImageInfo fbfont,h,w,bpp,pitch,pixels,size

   For buf As Integer = pitch-4 To size-1 Step 4

      pix = Cast(UInteger Ptr,@pixels[buf])

      If *pix =&hFFFF00FF OrElse *pix=  &h00FF00FF Then
         'nothing
      Else
         *pix = clr Or &hFF000000
      End If

   Next

End Sub

Sub _Font.DrawString(dest As Any Ptr=0, x As Integer, y As Integer, text As String)

   Draw String dest,(x,y),text,,fbfont

End Sub

Function _Font.LoadFBFont (Filename As String) As Any Ptr
   
   Function=0
   If UCase(Right(filename,4))=".BMP" Then
      Filename=Left(Filename,(Len(Filename)-4))
      Dim As Integer ff,junk
      Dim As Integer imgwidth,imgheight,PlotType,firstchar,lastchar,AdvanceX
      Dim As Any Ptr img,bmp,imgpxldata
      Dim As UByte Ptr Header

      ff=FreeFile
      Open Filename & ".descriptor" For Input As ff
      Input #ff, imgwidth
      Input #ff, imgheight
      Input #ff, PlotType
      Input #ff, junk
      Input #ff, firstchar
      Input #ff, lastchar

      If PlotType=1 Then
         img=ImageCreate (imgwidth,imgheight+1)
         bmp=ImageCreate (imgwidth,imgheight)
         If (img<>0) And (bmp<>0) Then
            ImageInfo(img,,,,,imgpxldata)
            BLoad (Filename & ".bmp",bmp)
            Header=imgpxldata'Startadresse Zeile 0 fr FBFontheader
            Header[0]=0
            Header[1]=firstchar
            Header[2]=lastchar
            For i As Integer=firstchar To lastchar
               Input #ff, junk'Daten werden nicht bentigt
               Input #ff, junk
               Input #ff, AdvanceX
               Input #ff, junk
               Input #ff, junk
               Input #ff, junk
               Input #ff, junk
               Header[3 + i-firstchar]=AdvanceX
            Next i
            Put img,(0,1),bmp,(0,0)-(imgwidth-1,imgheight-1),PSet
            ImageDestroy bmp
            Function=img
         End If
      End If
      Close ff
   End If
End Function
